module Config where

defaultFormat = "%S - %sx%2e - %E.%l"

data Config
    = Config
    { confVerbose  :: Int
    , confWGetPath :: String
    , confCurlPath :: String
    , confTidyPath :: String
    , confDryRun   :: Bool
    } deriving Show

data Action
    = Parse  { parseFormat :: String }
    | Rename { parseFormat :: String }
    | Inform { fromFiles :: [(String,FilePath)] }        -- Gather meta information.
    | Add
    | Remove
    | Move   { moveFormat :: String, moveDirectory :: FilePath }
      deriving Show

data Flag
    = HelpFlag
    | Verbose Int
    | WGetPath String
    | TidyPath String
    | DryRun Bool
      -- For Parse
    | ParseFormat String
      -- For Inform
    | FromFile (String,FilePath)
      -- For Move
    | MoveFormat String
    | MoveDirectory FilePath
      deriving Show

